function [Vnew,policy] = golden_mat(V,agrid,P,EV,coh,beta,amin,Na,Nz,ROW,COL)

r1 = (sqrt(5.0) - 1.0) / 2.0;
r2 = 1.0 - r1;

lb = amin;
resources = coh(ROW + (COL-1) * Na);
ub = resources;

bb = r1 * lb + r2 * ub;

pos = sum(bb>agrid);
if (pos == Na)
    pos = Na - 1;
elseif (pos == 0)
    pos = 1;
end
%check if the expected value function has already been computed. If not, compute it
if (EV(pos + (COL-1) * Na) < -99999)
    EVE = 0;
    for i2 = 1: Nz
        EVE = EVE + P((COL-1) * Nz + i2) * V(pos + (i2-1) * Na);
    end
    EV(pos + (COL-1) * Na) = EVE;
end
if (EV(pos + 1 + (COL-1) * Na) < -99999)
    EVE = 0;
    for i2 = 1: Nz
        EVE = EVE + P((COL-1) * Nz + i2)  * V(pos + 1 + (i2-1) * Na);
    end
    EV(pos+1 + (COL-1) * Na) = EVE;
end
util = log(resources - bb);
cont = EV(pos + (COL-1) * Na) + (EV(pos + 1 + (COL-1) * Na) - EV(pos + (COL-1) * Na)) * (bb - agrid(pos)) / (agrid(pos + 1) - agrid(pos));
val_b = util + beta * cont;


cc = r2 * lb + r1 * ub;
pos = sum(cc>agrid);
if (pos == Na)
    pos = Na - 1;
elseif (pos == 0)
    pos = 1;
end
%check if the expected value function has already been computed. If not, compute it
if (EV(pos + (COL-1) * Na) < -99999)
    EVE = 0;
    for i2 = 1: Nz
        EVE = EVE + P((COL-1) * Nz + i2) * V(pos + (i2-1) * Na);
    end
    EV(pos + (COL-1) * Na) = EVE;
end
if (EV(pos + 1 + (COL-1) * Na) < -99999)
    EVE = 0;
    for i2 = 1: Nz
        EVE = EVE + P((COL-1) * Nz + i2)  * V(pos + 1 + (i2-1) * Na);
    end
    EV(pos+1 + (COL-1) * Na) = EVE;
end
util = log(resources - cc);
cont = EV(pos + (COL-1) * Na) + (EV(pos + 1 + (COL-1) * Na) - EV(pos + (COL-1) * Na)) * (cc - agrid(pos)) / (agrid(pos + 1) - agrid(pos));
val_c = util + beta * cont;


while (abs(lb - ub) > 0.001 * (abs(bb) + abs(cc)))
    if (val_b > val_c)
        ub = cc;
        cc = bb;
        val_c = val_b;
        bb = r1 * lb + r2 * ub;
        pos = sum(bb>agrid);
        if (pos == Na)
            pos = Na - 1;
        elseif (pos == 0)
            pos = 1;
        end
        %check if the expected value function has already been computed. If not, compute it
        if (EV(pos + (COL-1) * Na) < -99999)
            EVE = 0;
            for i2 = 1: Nz
                EVE = EVE + P((COL-1) * Nz + i2) * V(pos + (i2-1) * Na);
            end
            EV(pos + (COL-1) * Na) = EVE;
        end
        if (EV(pos + 1 + (COL-1) * Na) < -99999)
            EVE = 0;
            for i2 = 1: Nz
                EVE = EVE + P((COL-1) * Nz + i2)  * V(pos + 1 + (i2-1) * Na);
            end
            EV(pos+1 + (COL-1) * Na) = EVE;
        end
        util = log(resources - bb);
        cont = EV(pos + (COL-1) * Na) + (EV(pos + 1 + (COL-1) * Na) - EV(pos + (COL-1) * Na)) * (bb - agrid(pos)) / (agrid(pos + 1) - agrid(pos));
        val_b = util + beta * cont;


    else
        lb = bb;
        bb = cc;
        val_b = val_c;
        cc = r2 * lb + r1 * ub;
        pos = sum(cc>agrid);
        if (pos == Na)
            pos = Na - 1;
        elseif (pos == 0)
            pos = 1;
        end
        %check if the expected value function has already been computed. If not, compute it
        if (EV(pos + (COL-1) * Na) < -99999)
            EVE = 0;
            for i2 = 1: Nz
                EVE = EVE + P((COL-1) * Nz + i2) * V(pos + (i2-1) * Na);
            end
            EV(pos + (COL-1) * Na) = EVE;
        end
        if (EV(pos + 1 + (COL-1) * Na) < -99999)
            EVE = 0;
            for i2 = 1: Nz
                EVE = EVE + P((COL-1) * Nz + i2)  * V(pos + 1 + (i2-1) * Na);
            end
            EV(pos+1 + (COL-1) * Na) = EVE;
        end
        util = log(resources - cc);
        cont = EV(pos + (COL-1) * Na) + (EV(pos + 1 + (COL-1) * Na) - EV(pos + (COL-1) * Na)) * (cc - agrid(pos)) / (agrid(pos + 1) - agrid(pos));
        val_c = util + beta * cont;
    end

end

if (val_b > val_c)
    policy = bb;
    Vnew = val_b;

else
    policy = cc;
    Vnew = val_c;
end

end